﻿////////////////////////////////////////////////////////////////////////////////
//
// AudioscrobblerReader
//   ScrollTextField.as
//   Rev. 1.1 (2005/9/25)
// 
// by nomura masayuki
// http://www.a3size.com/AudioscrobblerReader/
//
////////////////////////////////////////////////////////////////////////////////
//
// スクロールテキストムービークリップクラス
// テキストフィールドをスクロールさせる機能を持ったムービークリップのクラス
//
////////////////////////////////////////////////////////////////////////////////
import com.a3size.audioscrobblerReader.*;

class com.a3size.audioscrobblerReader.ScrollTextField extends MovieClip
{
	// テキストフィールドのインスタンスをメンバーとして定義
	var field:TextField;

	static private var SCROLL_INTERVAL:Number = 12; // スクロールを再開するまでのインターバル
	private var scrollSpeed:Number; // スクロール速度
	private var originalSize:Number; // テキストフィールドの本来の幅
	private var originalPosition:Number; // テキストフィールドのスタート位置
	private var scrollTimer:Number = 0; // スクロール制御用変数
	
	// コンストラクタ
	function ScrollTextField()
	{
		field.autoSize = "left";
		originalPosition = field._x;
		originalSize = this._width;
		scrollSpeed = 1;
	}
	
	// スクロールスピード(get/set)
	function get speed():Number
	{
		return this.scrollSpeed;
	}
	function set speed(num:Number):Void
	{
		this.scrollSpeed = num;
	}

	// 表示テキスト(get/set)
	function get text():String
	{
		return field.text;
	}
	function set text(str:String):Void
	{
		field.text = str;
		field._x = originalPosition;

		// サイズがはみ出していたらスクロール開始
		if ((field._width - originalSize) >= 1)
		{
			this.onEnterFrame = scrollText;
		}
		else
		{
			this.onEnterFrame = null;
			field._x = (originalSize - field._width) / 2; // 中央揃え
		}
	}

	// テキストスクロール制御
	private function scrollText():Void
	{
		// 現在のテキストの位置を確認
		if ((field._width + field._x - originalSize) >= 1)
		{
			if (scrollTimer > 0) // インターバル待ち(その2) 再び左端に戻ってきた状態
				scrollTimer--;
			else
				field._x -= scrollSpeed;
		}
		else
		{
			// インターバル待ち(その1) 右端まで表示された状態
			scrollTimer++;
			if (scrollTimer > SCROLL_INTERVAL)
			{
				field._x = originalPosition;
			}
		}
	}
}